! In this example, a dataset is created containing
! a 3-dimensional array. The array is filled with unique
! numbers, before the dataset is released (closed).
!
! The dataset is then reopened (with READ access),
! and the array's data is displayed.
program example_array

  use dal
  use errorhandling

  implicit none

  type(DataSetT) set
  type(ArrayT) arr
  integer(kind=int32), dimension(:,:,:), pointer :: a
  integer(kind=int32), dimension(:), pointer :: ad
  integer, dimension(3), parameter :: s = (/ 3,4,2 /)
  integer :: i,j,k,n

  ! create a set
  set = dataSet("test.dat",CREATE)
  arr = addArray(set, "some array", INTEGER32, dimensions=s )

  ! fill with unique numbers
  a => int32Array3Data(arr)

  n = 0
  do k=0,1
    do j=0,3
      do i=0,2 
        a(i,j,k) = n
        n = n + 1
      end do
    end do
  end do

  call release(arr)
  call release(set)

  ! create a set
  set = dataSet("test.dat",READ)
  arr = array(set, "some array", READ)
  ad => int32Data( arr )

  do n = 0, numberOfElements( arr ) - 1
    write(*,*) ad( n )
  end do

  call release(set)

end program example_array
