! This example shows how boolean attributes are used.
! The program creates a dataset containing two boolean attributes,
! together with a table containing two boolean attributes.
! The attributes are then accessed, by name, with
! the booleanAttribute() function.
! Also, it is shown how to access the attributes by position.
program example_booleanattribute
   
  use dal
  use errorhandling
  implicit none
   
  type(DataSetT) set
  type(TableT) tab
  type(AttributeT) att
  integer i

  set = dataSet("test.dat",CREATE)
  call setAttribute(set,"sbool1",.false.,"dataset bool comment")
  call setAttribute(set,"sbool2",.true.,"dataset bool comment")
   
  tab = addTable(set,"table",10);
  call setAttribute(tab,"sbool1",.false.,"dataset bool comment")
  call setAttribute(tab,"sbool2",.true.,"dataset bool comment")

  write(*,*) booleanAttribute( set, "sbool1" ) ! output 'F'
  write(*,*) booleanAttribute( set, "sbool2" ) ! output 'T'
  write(*,*) booleanAttribute( tab, "sbool1" ) ! output 'F'
  write(*,*) booleanAttribute( tab, "sbool2" ) ! output 'T'

  do i = 0, numberOfAttributes( set ) - 1
  	att = attribute( set, i )
	write(*,*) booleanAttribute( att ) ! output the sequence 'F','T'
  end do

  call release(set)
   
end program example_booleanattribute
