! This examples shows how the columnNumber() function
! is used.
program example_columnnumber

  use dal
  
  implicit none

  type(DataSetT) set
  type(TableT) tab
  type(ColumnT) col
  integer i

  set = dataSet("test.dat",CREATE)
  tab = addTable(set,"some table",100)

  col = addColumn(tab,"int16",INTEGER16,units="dm",comment="int16 column")
  col = addColumn(tab,"int32",INTEGER32,units="m",comment="in32 column")
  col = addColumn(tab,"real32",REAL32,units="Dm",comment="real32 column")

  col = addColumn(tab,"real64",REAL64,units="hm",comment="real64 column", &
          position=columnNumber( tab, "int32" ) )

  do i = 0, numberOfColumns( tab ) - 1
    col = column( tab, i, READ )
    write(*,*) name( col )
  end do

  call release(set)

end program example_columnnumber
