! This example shows how the deleteAttribute inteface is
! used.
subroutine deleteAllAttributes( attrib )
  use dal
  implicit none

  type(AttributableT) attrib
  type(AttributeT) att
  integer i

  do i = 0, numberOfAttributes( attrib ) - 1
    att = attribute( attrib, 0 )
    write(*,*) "deleting attribute with name ", name( att )
    call deleteAttribute( att )
  end do

end subroutine deleteAllAttributes

program example_deleteattribute

  use dal
  implicit none
   
  type(DataSetT) set
  type(TableT) tab
  type(ArrayT) arr
   
  set = dataSet("test.dat",CREATE)
  call setAttribute(set,"sbool1",.false.,"dataset bool comment")
  call setAttribute(set,"sbool2",.true.,"dataset bool comment")
  call setAttribute(set,"sbool3",.false.,"table bool comment")
  call setAttribute(set,"sbool4",.true.,"table bool comment")
   
  tab = addTable(set,"table",10);
  call setAttribute(tab,"sbool1",.false.,"table bool comment")
  call setAttribute(tab,"sbool2",.true.,"table bool comment")
  call setAttribute(tab,"sbool3",.false.,"table bool comment")
  call setAttribute(tab,"sbool4",.true.,"table bool comment")

  write(*,*) numberOfAttributes( set )
  call deleteAllAttributes( attributable( set ) )
  write(*,*) numberOfAttributes( set )
  write(*,*) numberOfAttributes( tab )
  call deleteAllAttributes( attributable( tab ) )
  write(*,*) numberOfAttributes( tab )

  call release(set)
   
end program example_deleteattribute
