! In this example add dataset is created (opened) containing
! a table with 2 columns of two 3-dimensional arrays.
!
! The second array has the same data type as the first; this
! is ensured by using the arrayDataType() function to determine
! the data type of the first array.
!
! The columns are then  initialised before the
! dataset is released (closed).
program example_array3data

  use dal
  use errorhandling

  implicit none

  type(DataSetT) set
  type(TableT) tab
  type(ColumnT) col1, col2
  integer(kind=INT32), dimension(:,:,:,:), pointer :: c1, c2
  integer, dimension(3), parameter :: s = (/ 3,4,5 /)
  integer :: i,j,k,l,n

  ! create a set
  set = dataSet("test.dat",CREATE)
  tab = addTable(set, "table", 100, "table comment" )
  col1 = addColumn( tab, "column1", INTEGER32, "km", s, "column comment" )
  col2 = addColumn( tab, "column2", columnDataType( col1 ), "km", s, "column comment" )

  ! fill with unique numbers
  c1 => int32Array3Data(col1)
  c2 => int32Array3Data(col1)

  n = 0
  do l=0,numberOfRows(tab) - 1
    do k = 0,4
      do j=0,3
        do i=0,2 
          c1(i,j,k,l) = n
          c2(i,j,k,l) = c1(i,j,k,l)
          n = n + 1
        end do
      end do
    end do
  end do

  call release(col1)
  call release(col2)
  call release(set)

end program example_array3data
