using namespace std;
#include <Dal.h>
#include <iostream>
#include <cmath>

class Report : public TableProcessor {

  void table(Table* t) {
    xData = t->column("x",Dal::Read)->data();
    yData = t->column("y",Dal::Read)->data();
    rData = t->column("r",Dal::Create)->data();
  }

  void proc(Table& tab) {
    int16  *x = xData->int16Data();
    int16  *y = yData->int16Data();
    real64 *r = rData->real64Data();

    for (unsigned i = 0; i < tab.count(); ++i) {
      clog << x[i] << ' ' << y[i] << endl;
      r[i] = sqrt( sqr(x[i]) + sqr(y[i]) );
    }
  }

  ColumnData *xData, *yData, *rData;
};

int main()
{
  DataSet *set = dataSetServer->open("test.dat",
	DataSet::Modify);
  Table* table = set->table("events",Table::Modify);
  Report report;
  report.process(table);
  delete set;
  return 0;
}
