/*************************************************************** 
* 
* HiLowDataSet.h               & XMM Science Analysis System (SAS) 
* 
* Class representing a DAL Data Set.
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: HiLowDataSet.h,v 1.2 2004/03/05 14:43:02 eojero Exp $ 
* 
*****************************************************************/ 
#ifndef HILOW_DATA_SET_H
#define HILOW_DATA_SET_H


#include "Dal.h"
#include "DalBlock.h"
#include "DalDataSet.h"


class HiLowDataSet : public DalDataSet
{
	public :

		// Constructors
		HiLowDataSet(
				const std::string &			setName,
				AccessMode			openMode,
				DalDataSetServer *		server,
				DataSetReaderWriter*		readerWriter );
		HiLowDataSet( const HiLowDataSet & );
		//DalDataSet& operator=( const DalDataSet& );

		DalTable * makeTable(
			const std::string &		name,
			const std::string &		label,
			unsigned long		rows,
			DalDataSet *		parent );

		DalArray * makeArray(
			const std::string &			name,
			DataType			dataType,
			const longVec&			size,
			const std::string &			units,
			const std::string &			label,
			DalDataSet *			parent );

		virtual ~HiLowDataSet();

		void		printOn( ostream & os ) const;

	private :
		
		void readmodify();
		void createtemp( DataSetServer* server );

};


#endif
