using namespace std;
#include <Dal.h>
#include<cassert>

int main()
{
  DataSet* set = dataSetServer->open("test.dat",DataSet::Create);
  assert( set -> blocks() == 0 );
  vector<unsigned long> size;
  size.push_back(3);
  size.push_back(4);
  set->addArray("PRIMARY", Array::Int8, size );
  assert( set -> blocks() == 1 );
  set->addTable("table1",100);
  assert( set -> blocks() == 2 );
  set->addArray("array2", Array::Int8, size );
  assert( set -> blocks() == 3 );
  set->addArray("array3", Array::Int8, size );
  assert( set -> blocks() == 4 );
  set->addTable("table2",100);
  assert( set -> blocks() == 5 );
  set->addTable("table3",100);
  assert( set -> blocks() == 6 );
  dataSetServer->close(set);


  set = dataSetServer->open("test.dat",DataSet::Modify);
  assert( set -> blocks() == 6 );
  set -> deleteBlock( "table1" );
  assert( set -> blocks() == 5 );
  dataSetServer->close(set);

  set = dataSetServer->open("test.dat",DataSet::Modify);
  assert( set -> blocks() == 5 );
  set -> deleteBlock( "array2" );
  assert( set -> blocks() == 4 );
  set -> deleteBlock( "table3" );
  assert( set -> blocks() == 3 );
  dataSetServer->close(set);

  set = dataSetServer->open("test.dat",DataSet::Modify);
  assert( set -> blocks() == 3 );
  set -> deleteBlock( "table2" );
  assert( set -> blocks() == 2 );
  set -> deleteBlock( "array3" );
  assert( set -> blocks() == 1 );
  dataSetServer->close(set);

  set = dataSetServer->open("test.dat",DataSet::Modify);
  assert( set -> blocks() == 1 );
  set -> deleteBlock( "PRIMARY" );
  assert( set -> blocks() == 0 );
  dataSetServer->close(set);

  set = dataSetServer->open("test.dat",DataSet::Read);
  assert( set -> blocks() == 0 );
  dataSetServer->close(set);

  return 0;
}

