#include <Dal.h>
#include <string>
#include <iostream>
#include <cassert>

int main() {

    std::string name("test.dat");
    longVec dim;
    dim.push_back(10);
    DataSet * set = dataSetServer->open(name, Dal::Create);
    Table * tab = set->addTable("Table", 100);
    Column * col = tab->addColumn("Column", Dal::Int32, "", "", dim);
    for(unsigned irow = 0; irow < tab->rows(); ++irow){
	ColumnData * cd = col->rowData(irow);
	int32 * v = cd->int32Data();
	for(unsigned icell = 0; icell < cd->elements(); ++icell){
	    v[icell] = irow*1000 + icell;
	}
	delete cd;
    }

    col = tab->addColumn("ColumnV", Dal::Int32, "", "", Dal::zero);
    for(unsigned irow = 0; irow < tab->rows(); ++irow){
	CellData * cd = col->cellData(irow);
	cd->size(irow);
	int32 * v = cd->int32Data();
	for(unsigned icell = 0; icell < cd->elements(); ++icell){
	    v[icell] = irow*1000 + icell;
	}
	delete cd;
    }

    dataSetServer->close(set);

    set = dataSetServer->open(name, Dal::Read);
    tab = set->table("Table");
    col = tab->column("Column");
    for(unsigned irow = 0; irow < tab->rows(); ++irow){
	ColumnData * cd = col->rowData(irow);
	int32 * v = cd->int32Data();
	for(unsigned icell = 0; icell < cd->elements(); ++icell){
	    long expect = irow*1000 + icell;
	    assert(expect == v[icell]);
	}
	delete cd;
    }

    dataSetServer->close(set);


}
	

