
subroutine fill( set, nRows )

  use dal

  implicit none
  
  type(DataSetT) set
  integer nRows
  type(TableT) tab
  type(ColumnT) col
  real(kind=single), dimension(:), pointer :: c
  integer m

  tab = addTable(set, "table", nRows, "table comment" )
  col = addColumn( tab, "column1", REAL32, "km", (/ 1 /), "column comment" )

  do m=0,numberOfRows(tab)-1
     c => real32Data(col,m)
     c = m+3
     if(modulo(m,1000) .eq. 0)then
        write(*,*)m
     end if
     call release(col)
  end do
  call release(tab)
end subroutine fill


subroutine check( set )

  use dal
  use errorHandling

  implicit none
  
  type(DataSetT) set
  type(TableT) tab
  type(ColumnT) col
  real(kind=single), dimension(:), pointer :: c
  integer m

  tab = table( set, "table" )
  col = column( tab, "column1" )

  do m=0,numberOfRows(tab)-1
     c => real32Data(col,m)
       if( any( c /= m + 3 )) call error( "Test failed" )

     if(modulo(m,1000) .eq. 0)then
        write(*,*)m
     end if
     call release(col)
  end do
  call release(tab)
end subroutine check


subroutine dotest( nRows )

  use dal

  implicit none
  
  type(DataSetT) set
  integer nRows

  set = dataSet("test.dat",CREATE)
  call fill( set, nRows )
  call check( set )
  call release(set)

  set = dataSet("test.dat",READ)
  call check( set )
  call release(set)
end subroutine dotest


program test

  use dal

  implicit none

  call dotest( 10000 )

end program test

