using namespace std;
//
// XMM Science Analysis System
//
// Giuseppe Vacanti (cosine science & computing) 
// October 2001
//
#include<Dal.h>
#include<string>
#include<ExceptionErrorHandler.h>
#include<errstr.h>
#include<cassert>
/* AI gcc4 porting
 * 'exit' was not declared in this scope => include cstdlib.h
 */
#include <cstdlib>
int main() {

  ExceptionErrorHandler thrower;
  errHandler.handler(&thrower);

  // ds("x.ds") -> Could not find block with qualified name 'x:x' in dataset with name 'x', whereas it should indicate that no table name was given.
  std::string ds("x.ds");
  DataSet * set =  dataSetServer->open(ds, Dal::Create);
  
  try {
    set->table(ds);
  }
  // I rely on a specific string to be in the error message
  catch(SasException::Exception e){
    std::cout << "Failed with " << e.message << std::endl;    
    assert(e.message.find("Most likely you failed to specify append a ':' to") !=
	   std::string::npos);
    std::cout << "Failed as expected with " << e.message << std::endl;    
    exit(0);
  }
  exit(1);

}
    
  
