//  Giuseppe Vacanti (cosine science & computing bv)
//  September  9, 2002
// 
//   $Id: spr2338.cc,v 1.3 2009/06/22 15:58:03 rsaxton Exp $
#include <Dal.h>
#include<string>
#include <cassert>
#include<iostream>
#include<cstdlib>

// The test dataset contains DATE in a table extension. It is supposed
// to be able to read that table, and after the dataset has been
// closed there should be no DATE attribute anymore. At the moment
// this cannot be tested because there is no way to inquire about the
// DATE attribute in a table.

// We use cfitsio directly to create and test the anomalous dataset.
#include<fitsio.h>
#include<longnam.h>

int main() {

    int status = -1;
    
    std::string name("spr2338.ds");

    std::string cmd("rm -f " + name);
    system(cmd.c_str());

    fitsfile *fptr;
    fits_create_file(&fptr, name.c_str(), &status);
    fits_create_tbl(fptr, BINARY_TBL, 0, 0, 0, 0, 0, "table", &status);
    /* AI gcc4 porting
     * deprecated conversion from string constant to char*=> cast to (char*)
     */
    char * value = (char*) "date";
    fits_write_key(fptr, TSTRING, "DATE", value, 0, &status);
    fits_close_file(fptr, &status);
    std::cerr << status << std::endl;
    assert(status == 0);

    DataSet * set = 0;
    set = dataSetServer->open(name, Dal::Modify);
    dataSetServer->close(set);
    // Here the DATE attribute in the table has disappeared

    set = dataSetServer->open(name, Dal::Read);
    dataSetServer->close(set);

    int type;
    fits_open_file(&fptr, name.c_str(), READONLY, &status);
    std::cerr << status << std::endl;
    fits_movabs_hdu(fptr, 2, &type, &status);
    std::cerr << status << std::endl;
    char card[80];
    fits_read_card(fptr, "DATE", card, &status);
    std::cerr << status << std::endl;
    assert(status == KEY_NO_EXIST);
    status = 0;
    fits_close_file(fptr, &status);
    std::cerr << status << std::endl;
    assert(status == 0);


}
