using namespace std;
#include <string>
#include <Dal.h>
#include <ErrorHandling.h>
#include <fstream>

void writeFits(const string& dataset, const string& fitsfile)
{
  DataSet *set = dataServer->open(dataset,Read);

  ofstream ofs(fitsfile.c_str());
  if (!ofs) Error("fileCreate",("Cannot create file "+fitsfile).c_str());

  dataServer->close(set);
}

int main(int argc, char *argv[])
{
  if (argc != 3)
	Error("commandLineArguments",
	      ("usage: "+string(argv[0])+" <dataset> <fitsfile>").c_str());
  writeFits(argv[1],argv[2]);
}
